"use strict";

Object.seal(Object.defineProperties(exports, {
    defineProperty: {
        get: function() {
            return defineProperty;
        },

        enumerable: true
    },

    objCreate: {
        get: function() {
            return objCreate;
        },

        enumerable: true
    },

    fnBind: {
        get: function() {
            return fnBind;
        },

        enumerable: true
    }
}));

var src$utils$$ = require("./utils");

// Purposely using the same implementation as the Intl.js `Intl` polyfill.
// Copyright 2013 Andy Earnshaw, MIT License

var realDefineProp = (function () {
    try { return !!Object.defineProperty({}, 'a', {}); }
    catch (e) { return false; }
})();

var es3 = !realDefineProp && !Object.prototype.__defineGetter__;

var defineProperty = realDefineProp ? Object.defineProperty :
        function (obj, name, desc) {

    if ('get' in desc && obj.__defineGetter__) {
        obj.__defineGetter__(name, desc.get);
    } else if (!src$utils$$.hop.call(obj, name) || 'value' in desc) {
        obj[name] = desc.value;
    }
};

var objCreate = Object.create || function (proto, props) {
    var obj, k;

    function F() {}
    F.prototype = proto;
    obj = new F();

    for (k in props) {
        if (src$utils$$.hop.call(props, k)) {
            defineProperty(obj, k, props[k]);
        }
    }

    return obj;
};

var fnBind = Function.prototype.bind || function (thisObj) {
    var fn   = this,
        args = [].slice.call(arguments, 1);

    return function () {
        fn.apply(thisObj, args.concat([].slice.call(arguments)));
    };
};

//# sourceMappingURL=es5.js.map